#include <stdio.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "which";

#ifdef UX_COMPILE_TEST
#  define ENVPATH_SEP ':'
#  define ends_with_pathdelimiter_p(s) (!*(s) || (s)[strlen(s) - 1] == '/')
char	*chk_strduppathcat(d, p, f)
char	*d, *f;
int	p;
{
	static	char	buf[500];

	strcpy(buf, d);
	if(!ends_with_pathdelimiter_p(d) && *f) strcat(buf, "/");
	strcat(buf, f);
	return buf;
}
#else
#  define ENVPATH_SEP ';' /* 2oCgڂɂ͂ȂȂ */
#endif

static	int	display_all = 0, msdos_format = 0;
static	int	pathsep = PATH_SEP1;

#ifdef DEBUG
int	xaccess(s, n)
char	*s;
int	n;
{
	printf("searching <%s>\n", s);
	return access(s, n);
}
#  define access xaccess
#endif

static	void	_puterrmes1(c)
int	c;
{
	static	char	s[2] = "\0";

	*s = (char)c, _puterrmes(s);
}

static	void	usage_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-am] [-w windir] commandname...");
	exit(1);
}

static	bool	search_file(path, file, winflg)
char	*path, *file, *winflg;
{
	char	*fnamebuf, *p;
	bool	found_p = 0;
	int	plen, flen;

	fnamebuf = chk_malloc(
			(plen = strlen(path)) + (flen = strlen(file)) + 6);
				/* 5 for "/" + ".com" + '\0' */
	p = strcpy(fnamebuf, path) + plen;
	if(!ends_with_pathdelimiter_p(path)) *p++ = (char)pathsep;
	p = strcpy(p, file) + flen;

	if(NULL != strchr(file, '.')){ /* '.'͊2oCgڂɂȂȂ */
	 /* FILE already had the extention. */
		if(!access(fnamebuf, 0)){
			fputs(fnamebuf, stdout), putchar('\n');
			found_p = 1;
		}
	} else {
		static	char	*exts[] = {"com", "exe", "bat", "pif", "dll"};
		int	i;

		*p++ = '.';
		for(i = 0;
		    i < (winflg != NULL ? sizeof(exts) / sizeof(*exts) : 3);
		    ++i){
			strcpy(p, exts[i]);
			if(!access(fnamebuf, 0)){
				fputs(fnamebuf, stdout), putchar('\n');
				found_p = 1;
				if(!display_all) break;
			}
		}
	}
	free(fnamebuf);
	return found_p;
}

static	char	*path_scanned;

static	void	pathscan_init(path_variable)
char	*path_variable;
{
	path_scanned = path_variable;
}

static	char	*pathscan()
 /* ɌĂԂƑO̕Ԃ蕶free */
{
	char	*pathend;
	static	char	*pathbuf = NULL, curdir[ ] = ".";

	if(NULL != pathbuf){
		free(pathbuf);
		pathbuf = NULL;
	}

	if(path_scanned == NULL) return NULL;

	 /* ENVPATH_SEP͊2oCgڂɂ͂ȂȂ */
	if(NULL != (pathend = strchr(path_scanned, ENVPATH_SEP))){
		pathbuf = chk_malloc(pathend - path_scanned + 1);
		strncpy(pathbuf, path_scanned, pathend - path_scanned);
		pathbuf[pathend - path_scanned] = '\0';
		path_scanned = ++pathend;
	} else {
		pathbuf = chk_strdup(path_scanned);
		path_scanned = NULL;
	}
	if(!msdos_format) conv_to_unix_format(pathbuf);
	return *pathbuf ? pathbuf : curdir;
}

static	int	which_a_file(name, pathlist, windir)
char	*name, *pathlist, *windir;
{
	int	found = 0, i;
	bool	flg;
	char	*one_path, *one_path_w;
	static	char	*wdirs[] = {"system32", "system", NULSTR};

	conv_to_unix_format(name);
	if(NULL != windir && *windir){
		pathscan_init(windir);
		while(NULL != (one_path = pathscan())){
			for(i = 0; i < sizeof(wdirs) / sizeof(*wdirs); ++i){
				one_path_w = chk_strduppathcat(one_path,
							pathsep, wdirs[i]);
				flg = search_file(one_path_w, name, windir);
				free(one_path_w);
				if(flg){
					found = 1;
					if(!display_all) return 0;
				}
			}
		}
	}

	if(search_file(".", name, windir)){
		found = 1;
		if(!display_all) return 0;
	}

	pathscan_init(pathlist);
	while(NULL != (one_path = pathscan())){
		if(search_file(one_path, name, windir)){
			found = 1;
			if(!display_all) return 0;
		}
	}

	if(found) return 0;

	/* not found */
	 /* stderrɏoƂɂĂ݂BUNIXƂ͈قȂ邪 */
	_cmdputerrmes(name), _puterrmes(" not found in");
	if(windir != NULL){
		pathscan_init(windir);
		while(NULL != (one_path = pathscan())){
			for(i = 0; i < sizeof(wdirs) / sizeof(*wdirs); ++i){
				_puterrmes1(' '), _puterrmes(one_path);
				if(!ends_with_pathdelimiter_p(one_path) &&
				   *wdirs[i]) _puterrmes1(pathsep);
				_puterrmes(wdirs[i]);
			}
		}
	}
	_puterrmes(" .");
	pathscan_init(pathlist);
	while(NULL != (one_path = pathscan())){
		_puterrmes1(' '), _puterrmes(one_path);
	}
	_puterrmes_cr(NULSTR);
	return 1;
}

main(ac, av)
int	ac;
char	**av;
{
	char	*path, *windir = NULL;
	extern	int	optind, opterr;
	extern	char	*optarg;
	int	errcode, c, i;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(NULL == (path = getenv("PATH"))) path = NULSTR;

	opterr = 0;
#ifdef UX_COMPILE_TEST /* use normal getopt */
	while((c = getopt(ac, av, "amw:")) != EOF)
#else
	while((c = getopt(ac, av, "amw;")) != EOF)
#endif
	{
		switch(c){
		case 'a':
			display_all = 1;
			break;
		case 'm':
			msdos_format = 1, pathsep = PATH_SEP;
			break;
		case 'w':
			if(NULL == (windir = optarg) &&
			   NULL == (windir = getenv("windir")))
				windir = NULSTR;
#ifdef DEBUG
			fprintf(stderr, "windir = [%s]\n", windir);
#endif
			break;
		default:
			usage_exit();
		}
	}
	if(!(av += optind, ac -= optind)) usage_exit();

	for(errcode = i = 0; i < ac; ++i)
		if(0 != which_a_file(av[i], path, windir)) errcode = 1;
	return errcode;
}
